function [sobel_f_hist] = CalculateSobelFeatures(sobel_mag, sobel_theta, blockNum)
%	ÿͼƬӦ

[m, n] = size(sobel_mag);
sobel_f_hist = zeros(1,16*blockNum*blockNum);
for i = 1:m
    for j = 1:n
        row = floor((i-1)*blockNum/m+1);
        col = floor((j-1)*blockNum/m+1);
        blockIndex = (row-1)*blockNum+col;
        featureOffset = (blockIndex-1)*16;
        
        if (sobel_theta(i,j)>=-pi && sobel_theta(i,j)< -pi+pi/8)
            sobel_f_hist(1,1+featureOffset) = sobel_f_hist(1,1+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+pi/8 && sobel_theta(i,j)< -pi+(pi/8)*2)
            sobel_f_hist(1,2+featureOffset) = sobel_f_hist(1,2+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*2 && sobel_theta(i,j)< -pi+(pi/8)*3)
            sobel_f_hist(1,3+featureOffset) = sobel_f_hist(1,3+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*3 && sobel_theta(i,j)< -pi+(pi/8)*4)
            sobel_f_hist(1,4+featureOffset) = sobel_f_hist(1,4+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*4 && sobel_theta(i,j)< -pi+(pi/8)*5)
            sobel_f_hist(1,5+featureOffset) = sobel_f_hist(1,5+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*5 && sobel_theta(i,j)< -pi+(pi/8)*6)
            sobel_f_hist(1,6+featureOffset) = sobel_f_hist(1,6+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*6 && sobel_theta(i,j)< -pi+(pi/8)*7)
            sobel_f_hist(1,7+featureOffset) = sobel_f_hist(1,7+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*7 && sobel_theta(i,j)< -pi+(pi/8)*8)
            sobel_f_hist(1,8+featureOffset) = sobel_f_hist(1,8+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*8 && sobel_theta(i,j)< -pi+(pi/8)*9)
            sobel_f_hist(1,9+featureOffset) = sobel_f_hist(1,9+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*9 && sobel_theta(i,j)< -pi+(pi/8)*10)
            sobel_f_hist(1,10+featureOffset) = sobel_f_hist(1,10+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*10 && sobel_theta(i,j)< -pi+(pi/8)*11)
            sobel_f_hist(1,11+featureOffset) = sobel_f_hist(1,11+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*11 && sobel_theta(i,j)< -pi+(pi/8)*12)
            sobel_f_hist(1,12+featureOffset) = sobel_f_hist(1,12+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*12 && sobel_theta(i,j)< -pi+(pi/8)*13)
            sobel_f_hist(1,13+featureOffset) = sobel_f_hist(1,13+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*13 && sobel_theta(i,j)< -pi+(pi/8)*14)
            sobel_f_hist(1,14+featureOffset) = sobel_f_hist(1,14+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*14 && sobel_theta(i,j)< -pi+(pi/8)*15)
            sobel_f_hist(1,15+featureOffset) = sobel_f_hist(1,15+featureOffset)+sobel_mag(i,j);
        end
        if (sobel_theta(i,j)>=-pi+(pi/8)*15 && sobel_theta(i,j)<= -pi+(pi/8)*16)
            sobel_f_hist(1,8+featureOffset) = sobel_f_hist(1,8+featureOffset)+sobel_mag(i,j);
        end
    end
end

sobel_f_hist = sobel_f_hist';
end















